#ifndef CFONTMAP_H
#define CFONTMAP_H

/*
* CFontmap
* Manages a Fontmap Texture and provides basic text output
*/
class CFontmap
{
public:
	enum ERendermode{additive, alpha, invert, invert_additive, invert_alpha };
	enum EOrientation{left, center, right, block};

	struct SCharBox
	{
		float fXOffset;
		float fYOffset;
		float fXInc;
		float fXBox;
		float fYBox;
	};

	CFontmap();
	~CFontmap();
	CFontmap(char *csFontname, int iResolution, float fHeight, ERendermode rendermode);

	float set_height(float fHeight);
	bool create(char *csFontname, int iResolution=16);
	void set_pos(float fX, float fY);
	ERendermode set_rendermode(ERendermode const &rendermode)
	{
		ERendermode ret=m_rendermode;
		m_rendermode=rendermode;
		return ret;
	}

	void print(char *csText, int iMaxLength=-1);

	friend bool make_fontmap(char *csFontname, int iResolution, unsigned int uiChars, unsigned int uiColumns, unsigned int uiRows, CFontmap *pFontmap);

protected:
	unsigned int m_uiTexName;
	float m_fHeight;
	float m_fMaxWidth;

	float m_fStartX;
	float m_fStartY;
	float m_fCurrentX;
	float m_fCurrentY;

	unsigned int const c_uiChars;
	unsigned int const c_uiColumns;
	unsigned int const c_uiRows;

	SCharBox *m_pCBoxes;

	ERendermode m_rendermode;
};

bool make_fontmap(char *csFontname, int iResolution, unsigned int uiChars, unsigned int uiColumns, unsigned int uiRows, CFontmap *pFontmap);

#endif/*CFONTMAP_H*/